%getMouse.m - This file will read in the data file that records from
%MacroWhiz.  This data file stores the position of the mouse for a user 
%defined amount of timefixed amount

function data=getMouse(fname)
if (nargin<1)
    [fname fpath]=uigetfile('*.mb','Select mouse data file');
end

%Go through the file, reading in the data
fid = fopen( fname, 'r' );
disp(' ')
disp( strcat('Reading data from file: ', fname ) )
FileLine = 1;  %file line string
LineCounter = 0;  %file line number
while( FileLine(1) ~= -1 )  %go until end of file
    FileLine = fgets( fid );
    LineCounter = LineCounter+1;
    FileLineSize = size( FileLine );
    if( FileLineSize(2) < 3 )  %make sure fileline is big enough (ie. not -1)
        break;                          %Too short to be a data line
%        ReadingDataBlockFlag = FALSE;  %Too short to be a data line
    else
        %Just look for motion data, not mouse clicks or other macro flags
        if (FileLine(1:2)=='M:')
            FileLine=strrep(FileLine,'M:','');      %Get rid of file formatting
            FileLine=strrep(FileLine,',','');       %Get rid of file formatting
            FileLine=strrep(FileLine,'-',' ');      %Get rid of file formatting
            tempdata=sscanf(FileLine,'%d %d %d')';  %Read in 3 numbers from line data
            if LineCounter==1
                startTime=tempdata(3);
            end
            %Rearrange the data and convert time (Flip the y-axis)
            data(LineCounter,:)=[(tempdata(3)-startTime)/1000 tempdata(1) 1024-tempdata(2)];
        else
            LineCounter = LineCounter-1;
        end
    end
end
plot(data(:,2),data(:,3));
xlabel('X (pixels)'), ylabel('Y (pixels)')
title('Mouse movement in pixels')


